package com.aliyun.odps.spark.examples

import org.apache.spark.sql.SparkSession
import com.aliyun.odps.TableSchema
import com.aliyun.odps.data.Record
import org.apache.spark.aliyun.odps.OdpsOps
import examples.sparksql.SparkShareRatioSampleLoader.singleParse

import java.util
import java.util.ArrayList

object makedata_01_readhdfs {
  def main(args: Array[String]) {
    val spark = SparkSession
      .builder()
      .appName("WordCount")
      .getOrCreate()
    val sc = spark.sparkContext

    val accessKeyId = "LTAIWYUujJAm7CbH"
    val accessKeySecret = "RfSjdiWwED1sGFlsjXv0DlfTnZTG1P"
    val odpsUrl = "http://service.odps.aliyun.com/api"
    val tunnelUrl = "http://dt.cn-hangzhou.maxcompute.aliyun-inc.com"
    println("Read odps table...")

    val project = "loghubods"
    val table = "alg_recsys_view_sample"
    val partition = "dt=20231218"


    val odpsOps = OdpsOps(sc, accessKeyId, accessKeySecret, odpsUrl, tunnelUrl)
    val odpsData = odpsOps.readTable(project = project, table = table, partition = partition, transfer = read, numPartition = 5)
    println(s"Count (odpsData): ${odpsData.count()}")

    val hdfsPath = "/dw/recommend/model/share_ratio_samples/" + partition;
    odpsData.saveAsTextFile(hdfsPath);

  }

  def read(record: Record, schema: TableSchema): String = {
    val labelName = "share_ornot"
    val label = record.getString(labelName)
    val label_new = if (label == null || label == "1")
      "0"
    else
      "1"
    val result = singleParse(record, labelName)
    result
  }

}